﻿using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace AbstractTcpServer
{
    public class EchoServer : TcpServer
    {
        public EchoServer(IPAddress address, int port) : base(address, port)
        { }

        protected override void DoIt(TcpClient client)
        {
            try
            {
                NetworkStream stream = client.GetStream();
                StreamReader streamReader = new StreamReader(stream);
                string request = streamReader.ReadLine();
                Trace.WriteLine("Request: " + request);
                string response = request;
                StreamWriter streamWriter = new StreamWriter(stream);
                streamWriter.WriteLine(response);
                streamWriter.Flush();
                Trace.Write("Response: " + response);
            }
            finally
            {
                client.Close();
            }
        }
    }
}
